FLAME_UTIL_PATH="/FlameGraph"
#BCC_UTIL_PATH="/usr/share/bcc/tools"
FLAME_CPU=""
FLAME_PID=""
FLAME_OUTPUT="" # recorded perf data
FLAME_INTERVAL=5    # default 5s sample
FLAME_TYPE=0

flame_usage() {
	echo "Usage: $0 [OPTION]"
	echo "OPTION:"
	echo -e "\t-c, CPU number"
	echo -e "\t-p, pid number"
	echo -e "\t-o, output file"
	echo -e "\t-t, sample interval (second)"
#	echo -e "\t-T, sample type (0, on-cpu; 1, off-cpu)"
	echo -e "\t-h, show this info"
}

parse_record_param() {
	while getopts "c:p:o:t:hT:" o; do
		case "${o}" in
		c)
			FLAME_CPU=${OPTARG}
			;;
		p)
			FLAME_PID=${OPTARG}
			;;
		o)
			FLAME_OUTPUT=${OPTARG}
			;;
		t)
			FLAME_INTERVAL=${OPTARG}
			;;
#		T)
#			FLAME_TYPE=${OPTARG}
#			;;
		h)
			flame_usage
			exit 0
			;;
		*)
			;;
		esac
	done
}

record_data() {
	parse_record_param $@
	[ ! -z "$FLAME_CPU" ] && PERF_CPU="-C $FLAME_CPU"
	[ ! -z "$FLAME_PID" ] && PERF_PID="-p $FLAME_PID"
	[ ! -z "$FLAME_INTERVAL" ] && PERF_INTERVAL="-- sleep $FLAME_INTERVAL"
	[ -z "$FLAME_OUTPUT" ] && FLAME_OUTPUT="perf.data"  # follow default output of perf toolME_OUTPUT

#	if [ $FLAME_TYPE -eq 0 ];then
	PERF_OUTPUT="-o $FLAME_OUTPUT"
	perf record -g --kernel-callchains $PERF_CPU $PERF_PID $PERF_OUTPUT $PERF_INTERVAL
#	else
#		$BCC_UTIL_PATH/offcputime -df $PERF_PID $FLAME_INTERVAL > $FLAME_OUTPUT
#	fi
}

generate_flamegraph() {
	if [ ! -d "$FLAME_UTIL_PATH" ];then
		git clone http://github.com/brendangregg/FlameGraph $FLAME_UTIL_PATH
		[ $? -ne 0 ] && exit 1
		cd $FLAME_UTIL_PATH
		git reset --hard d9fcc272b6a08c3e3e5b7919040f0ab5f8952d65
		cd - > /dev/null
	fi
#	if [ $FLAME_TYPE -eq 0 ];then
	perf script -i $FLAME_OUTPUT | $FLAME_UTIL_PATH/stackcollapse-perf.pl --all | $FLAME_UTIL_PATH/flamegraph.pl > ${FLAME_OUTPUT}.svg
#	else
#		$FLAME_UTIL_PATH/flamegraph.pl --color=io --title="Off-CPU Time Flame Graph" --countname=us ${FLAME_OUTPUT} > ${FLAME_OUTPUT}.svg
#	fi
}

record_data $@
generate_flamegraph

