#!/usr/bin/python
import os, sys, signal, time

inited = 0
start_pos = 3
end_pos = 13
state_val_list=[11]
display_items = 14

# /proc/diskstats
# device number (major minor), device name
# rd_ios, rd_merges, rd_sectors, rd_ticks
# wr_ios, wr_merges, wr_sectors, wr_ticks
# io_pgr, tot_ticks, rq_ticks


if len(sys.argv) == 2:
    interval = int(sys.argv[1]) # seconds
    if interval == 0:
        interval = 1
else:
    interval = 1

current_idx = 0
stat = [[], []]
disk_nr = int(os.popen("lsblk | grep -E 'nvme.*\>|sd[a-z]\>' | wc -l").readlines()[0])

def update_index():
    global inited, current_idx
    current_idx = int(current_idx ^ 1)
    inited = 1

def __calc(data, disk_list):
    global start_pos, end_pos, disk_nr, current_idx
    res = [[0.00 for x in range(display_items)] for y in range(disk_nr)]
    # r/s rMB/s rrqm/s %rrqm r_await | w/s wMB/s wrqm/s %wrqm w_await | aqu-sz rareq-sz wareq-sz | %util
    for i in range(disk_nr):
        res[i][0] = float(data[i][0]) / interval
        res[i][1] = float(data[i][2]) / (2048 * interval)
        res[i][2] = float(data[i][1]) / interval
        res[i][3] = 0.00 if (data[i][0] + data[i][1]) == 0 else (float(data[i][1]) / (data[i][0] + data[i][1]))
        res[i][4] = 0.00 if data[i][0] == 0 else (float(data[i][3]) / data[i][0])
    #####################################################################
        res[i][5] = float(data[i][4]) / interval
        res[i][6] = float(data[i][6]) / (2048 * interval)
        res[i][7] = float(data[i][5]) / interval
        res[i][8] = 0.00 if (data[i][4] + data[i][5]) == 0 else (float(data[i][5]) / (data[i][4] + data[i][5]))
        res[i][9] = 0.00 if data[i][4] == 0 else (float(data[i][7]) / data[i][4])
    #####################################################################
        res[i][10] = float(data[i][10]) / (interval * 1000)
        res[i][11] = 0.00 if data[i][0] == 0 else (float(data[i][2]) / (2 * data[i][0]))    # KB
        res[i][12] = 0.00 if data[i][4] == 0 else (float(data[i][6]) / (2 * data[i][4]))    # KB
    #####################################################################
        res[i][13] = float(data[i][9]) / (10 * interval)
    for i in range(disk_nr):
        print "%s\t" % (disk_list[i]),
        for j in range(14):
            print "%.2f " % (res[i][j]),
        print ""
    print ""

def calc_show():
    global inited, start_pos, end_pos, disk_nr, current_idx
    data = [[0.00 for x in range(end_pos - start_pos + 1)] for y in range(disk_nr)] # data[disk_nr][item_nr]
    disk_name_list = ['' for x in range(disk_nr)]
    if inited == 0:
        return
    for i in range(0, disk_nr): # all disk
        disk_name_list[i] = stat[current_idx][i].split()[2]
        for j in range(start_pos, end_pos + 1): # all items
            if j in state_val_list:
                data[i][j - start_pos] = int(stat[current_idx][i].split()[j])
                continue
            data[i][j - start_pos] = int(stat[current_idx][i].split()[j]) - int(stat[current_idx ^ 1][i].split()[j])
    #print tmp
    __calc(data, disk_name_list)

def getstat():
    stat[current_idx] = os.popen("cat /proc/diskstats | grep -E 'nvme.*\>|sd[a-z]\>'").readlines()  # stat[TIME_STAMP][DISK_NR]

while True:
    try:
        getstat()
        calc_show()
        update_index()
        time.sleep(interval)
    except KeyboardInterrupt:
        print "Interrupt by keyboard"
        sys.exit()

