#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <nccl.h>

/*
 * gcc -I /repo/nccl/src/include/ -I /usr/local/cuda-11.8/targets/x86_64-linux/include/ -L /usr/lib/ -o ./nccl_topo ./nccl_topo.c -lnccl
 */

#define NR_GPUS	4

int main(int argc, char* argv[])
{
	int i, devs[NR_GPUS];
	int ret = 1;
	ncclComm_t comms[NR_GPUS];

	setenv("NCCL_TOPO_DUMP_FILE", "/tmp/nccl-topo.log", 1);

	for (i = 0; i < NR_GPUS; i++)
		devs[i] = i;

	if (ncclCommInitAll(comms, NR_GPUS, devs) == ncclSuccess) {
		printf("Succeed\n");
		ret = 0;
	} else
		printf("Failed\n");
	return ret;
}
