#!/bin/sh

WORLD_SIZE=2
LOCAL_SIZE=1
MASTER_ADDR=10.156.7.38
MASTER_PORT=12312
FIRST_RANK=0
NR_ITERATION=32

do_exit()
{
	pkill -P $$
}

trap do_exit INT

while getopts w:l:s:m:p:i: key
do
	case $key in
	w)     WORLD_SIZE="$OPTARG";;
	l)     LOCAL_SIZE="$OPTARG";;
	s)     FIRST_RANK="$OPTARG";;
	m)     MASTER_ADDR="$OPTARG";;
	p)     MASTER_PORT="$OPTARG";;
	i)     NR_ITERATION="$OPTARG";;
	?)     printf "Usage: %s: [-w WORLD_SIZE] [-n LOCAL_SIZE] [-s FIRST_RANK] [-m MASTER_ADDR] [-p MASTER_PORT] [-i NR_ITERATION]\n" $0
		exit 2;;
	esac
done

echo "WORLD_SIZE=$WORLD_SIZE"
echo "LOCAL_SIZE=$LOCAL_SIZE"
echo "FIRST_RANK=$FIRST_RANK"
echo "MASTER_ADDR=$MASTER_ADDR"
echo "MASTER_PORT=$MASTER_PORT"
echo "NR_ITERATION=$NR_ITERATION"

echo > /tmp/nccl.log
echo > /tmp/nccl-topo.log
export NCCL_TOPO_DUMP_FILE=/tmp/nccl-topo.log
export NCCL_DEBUG_FILE=/tmp/nccl.log
export NCCL_DEBUG=INFO
export NCCL_DEBUG_SUBSYS=ALL

export WORLD_SIZE=$WORLD_SIZE
export LOCAL_SIZE=$LOCAL_SIZE
export MASTER_ADDR=$MASTER_ADDR
export MASTER_PORT=$MASTER_PORT
export NR_ITERATION=$NR_ITERATION
export NCCL_IB_GID_INDEX=3

#export CUDA_VISIBLE_DEVICES=3
#export NCCL_IB_DISABLE=1
#export NCCL_IBEXT_DISABLE=1
#export NCCL_GRAPH_FILE=/test/graph.xml

RANK=$FIRST_RANK
LAST_RANK=$(($FIRST_RANK + $LOCAL_SIZE))
while true;
do
    RANK=$RANK python test_nccl.py &
    echo "Rank $RANK started"
    RANK=$(($RANK + 1))
    if [ $RANK -ge $LAST_RANK ];then
            break
    fi
done

wait
