# cpu相关脚本

cpu相关脚本涵盖了自研接口bili_stat、perf、观察任务数量等相关内容。

## cpuacct.bilistat数据采集
cpuacct.bilistat接口主要功能是采集内核的cpu usage相关信息、loadavg、throttle预警、调度延迟统计等相关信息。该脚本可实现指定容器id和时间，实现获取该容器及其父亲、爷爷节点的cpuacct.bilistat接口内容，以及指定时间前后的数据差值。

## perf
perf主要是抓取指定间隔内的数据，目前只输出perf sched latency相关，后面根据工具使用情况，考虑新增或删减。

## 观察任务数量
考虑线上业务经常碰到throttle的情况，对于throttle的情况，目前可以通过bili_stat接口提前预警，这里统计瞬时运行的数量作为辅助验证手段，可作为发生throttle时业务方判断的途径之一

## 使用
- 参数
	- -T: 指定测试内容，目前包括bili_stat、perf、nr_workers三种
	- -d: 指定容器id
	- -t: 指定时间（单位：s)
- 示例
	- sched_test -T bili_stat -d 2324453545 -t 5
		- 等价于在容器所在目录下cat cpuacct.bili_stat;sleep 5;cat cpuacct.bili_stat;然后去其父亲节点，爷爷节点...，需要指定容器id和时间
	- sched_test -T perf -t 5 -a bash
		- 等价于perf sched record -- sleep 5;perf sched latency | grep bash，可指定时间和服务
	- sched_test -T nr_workers -a bash
		- nr_workers表示使用工具观察任务数量，-a表示统计的是bash，即统计bash的瞬时运行数量，业务方可更换bash为具体的服务
